From 539579cf7e523467ace66d1afcf52fddfd9522e5 Mon Sep 17 00:00:00 2001
From: Andres Freund <andres@anarazel.de>
Date: Mon, 11 Dec 2017 17:34:51 -0800
Subject: [PATCH] Remove out of date types.

Author:
Reviewed-By:
Discussion: https://postgr.es/m/
Backpatch:
---
 doc/src/sgml/brin.sgml                             |   11 -
 doc/src/sgml/catalogs.sgml                         |    4 +-
 doc/src/sgml/datatype.sgml                         |    8 -
 doc/src/sgml/func.sgml                             |   22 -
 doc/src/sgml/ref/create_function.sgml              |    2 +-
 doc/src/sgml/xfunc.sgml                            |   22 +-
 src/backend/access/hash/hashvalidate.c             |    1 -
 src/backend/catalog/system_views.sql               |    2 +-
 src/backend/utils/adt/Makefile                     |    2 +-
 src/backend/utils/adt/date.c                       |   50 -
 src/backend/utils/adt/formatting.c                 |    1 -
 src/backend/utils/adt/nabstime.c                   | 1571 --------------------
 src/backend/utils/adt/selfuncs.c                   |   17 -
 src/bin/pg_dump/pg_dumpall.c                       |    2 +-
 src/include/catalog/pg_aggregate.h                 |    2 -
 src/include/catalog/pg_amop.h                      |   46 -
 src/include/catalog/pg_amproc.h                    |   17 -
 src/include/catalog/pg_cast.h                      |   13 -
 src/include/catalog/pg_opclass.h                   |    7 -
 src/include/catalog/pg_operator.h                  |   65 -
 src/include/catalog/pg_opfamily.h                  |    7 -
 src/include/catalog/pg_proc.h                      |  102 --
 src/include/catalog/pg_type.h                      |   11 -
 src/include/utils/datetime.h                       |    2 +-
 src/include/utils/nabstime.h                       |  103 --
 src/interfaces/ecpg/ecpglib/execute.c              |    6 -
 src/interfaces/ecpg/ecpglib/pg_type.h              |    3 -
 src/interfaces/ecpg/test/expected/thread-thread.c  |    2 +-
 .../ecpg/test/expected/thread-thread_implicit.c    |    2 +-
 src/interfaces/ecpg/test/thread/thread.pgc         |    2 +-
 .../ecpg/test/thread/thread_implicit.pgc           |    2 +-
 src/test/regress/expected/abstime.out              |  136 --
 src/test/regress/expected/alter_table.out          |   30 +-
 src/test/regress/expected/horology.out             |  210 ---
 src/test/regress/expected/opr_sanity.out           |   29 +-
 src/test/regress/expected/reltime.out              |  109 --
 src/test/regress/expected/rules.out                |    2 +-
 src/test/regress/expected/sanity_check.out         |    3 -
 src/test/regress/expected/tinterval.out            |  172 ---
 src/test/regress/expected/triggers.out             |    2 +-
 src/test/regress/parallel_schedule                 |    2 +-
 src/test/regress/serial_schedule                   |    3 -
 src/test/regress/sql/abstime.sql                   |   67 -
 src/test/regress/sql/alter_table.sql               |   24 +-
 src/test/regress/sql/horology.sql                  |   62 -
 src/test/regress/sql/reltime.sql                   |   50 -
 src/test/regress/sql/tinterval.sql                 |   97 --
 src/test/regress/sql/triggers.sql                  |    2 +-
 48 files changed, 35 insertions(+), 3072 deletions(-)
 delete mode 100644 src/backend/utils/adt/nabstime.c
 delete mode 100644 src/include/utils/nabstime.h
 delete mode 100644 src/test/regress/expected/abstime.out
 delete mode 100644 src/test/regress/expected/reltime.out
 delete mode 100644 src/test/regress/expected/tinterval.out
 delete mode 100644 src/test/regress/sql/abstime.sql
 delete mode 100644 src/test/regress/sql/reltime.sql
 delete mode 100644 src/test/regress/sql/tinterval.sql

diff --git a/doc/src/sgml/brin.sgml b/doc/src/sgml/brin.sgml
index 23c0e05ed6c..bef1adead53 100644
--- a/doc/src/sgml/brin.sgml
+++ b/doc/src/sgml/brin.sgml
@@ -117,17 +117,6 @@
     </row>
    </thead>
    <tbody>
-    <row>
-     <entry><literal>abstime_minmax_ops</literal></entry>
-     <entry><type>abstime</type></entry>
-     <entry>
-      <literal>&lt;</literal>
-      <literal>&lt;=</literal>
-      <literal>=</literal>
-      <literal>&gt;=</literal>
-      <literal>&gt;</literal>
-     </entry>
-    </row>
     <row>
      <entry><literal>int8_minmax_ops</literal></entry>
      <entry><type>bigint</type></entry>
diff --git a/doc/src/sgml/catalogs.sgml b/doc/src/sgml/catalogs.sgml
index 3f02202cafb..16140725bb2 100644
--- a/doc/src/sgml/catalogs.sgml
+++ b/doc/src/sgml/catalogs.sgml
@@ -10558,7 +10558,7 @@ SELECT * FROM pg_locks pl LEFT JOIN pg_prepared_xacts ppx
 
      <row>
       <entry><structfield>valuntil</structfield></entry>
-      <entry><type>abstime</type></entry>
+      <entry><type>timestamptz</type></entry>
       <entry></entry>
       <entry>Password expiry time (only used for password authentication)</entry>
      </row>
@@ -11037,7 +11037,7 @@ SELECT * FROM pg_locks pl LEFT JOIN pg_prepared_xacts ppx
 
      <row>
       <entry><structfield>valuntil</structfield></entry>
-      <entry><type>abstime</type></entry>
+      <entry><type>timestamptz</type></entry>
       <entry>Password expiry time (only used for password authentication)</entry>
      </row>
 
diff --git a/doc/src/sgml/datatype.sgml b/doc/src/sgml/datatype.sgml
index 9aa9b28f3e2..0519ca1cfd8 100644
--- a/doc/src/sgml/datatype.sgml
+++ b/doc/src/sgml/datatype.sgml
@@ -1699,14 +1699,6 @@ MINUTE TO SECOND
     any application.
    </para>
 
-   <para>
-    The types <type>abstime</type>
-    and <type>reltime</type> are lower precision types which are used internally.
-    You are discouraged from using these types in
-    applications;  these internal types
-    might disappear in a future release.
-   </para>
-
    <sect2 id="datatype-datetime-input">
     <title>Date/Time Input</title>
 
diff --git a/doc/src/sgml/func.sgml b/doc/src/sgml/func.sgml
index 4dd9d029e69..163ca3849c9 100644
--- a/doc/src/sgml/func.sgml
+++ b/doc/src/sgml/func.sgml
@@ -7314,22 +7314,6 @@ SELECT regexp_match('abc01234xyz', '(?:(.*?)(\d+)(.*)){1,1}');
         <entry></entry>
        </row>
 
-       <row>
-        <entry>
-         <indexterm>
-          <primary>timeofday</primary>
-         </indexterm>
-         <literal><function>timeofday()</function></literal>
-        </entry>
-        <entry><type>text</type></entry>
-        <entry>Current date and time
-         (like <function>clock_timestamp</function>, but as a <type>text</type> string);
-         see <xref linkend="functions-datetime-current"/>
-        </entry>
-        <entry></entry>
-        <entry></entry>
-       </row>
-
        <row>
         <entry>
          <indexterm>
@@ -8155,7 +8139,6 @@ SELECT LOCALTIMESTAMP;
 transaction_timestamp()
 statement_timestamp()
 clock_timestamp()
-timeofday()
 now()
 </synopsis>
    </para>
@@ -8172,11 +8155,6 @@ now()
     differ during subsequent commands.
     <function>clock_timestamp()</function> returns the actual current time, and
     therefore its value changes even within a single SQL command.
-    <function>timeofday()</function> is a historical
-    <productname>PostgreSQL</productname> function.  Like
-    <function>clock_timestamp()</function>, it returns the actual current time,
-    but as a formatted <type>text</type> string rather than a <type>timestamp
-    with time zone</type> value.
     <function>now()</function> is a traditional <productname>PostgreSQL</productname>
     equivalent to <function>transaction_timestamp()</function>.
    </para>
diff --git a/doc/src/sgml/ref/create_function.sgml b/doc/src/sgml/ref/create_function.sgml
index fd229d11937..c8c2d400e91 100644
--- a/doc/src/sgml/ref/create_function.sgml
+++ b/doc/src/sgml/ref/create_function.sgml
@@ -331,7 +331,7 @@ CREATE [ OR REPLACE ] FUNCTION
        change even within a single table scan, so no optimizations can be
        made.  Relatively few database functions are volatile in this sense;
        some examples are <literal>random()</literal>, <literal>currval()</literal>,
-       <literal>timeofday()</literal>.  But note that any function that has
+       <literal>clock_timestamp()</literal>.  But note that any function that has
        side-effects must be classified volatile, even if its result is quite
        predictable, to prevent calls from being optimized away; an example is
        <literal>setval()</literal>.
diff --git a/doc/src/sgml/xfunc.sgml b/doc/src/sgml/xfunc.sgml
index bbc3766cc21..24af7061596 100644
--- a/doc/src/sgml/xfunc.sgml
+++ b/doc/src/sgml/xfunc.sgml
@@ -1542,7 +1542,7 @@ CREATE FUNCTION test(int, int) RETURNS int
     Even a function with no side-effects needs to be labeled
     <literal>VOLATILE</literal> if its value can change within a single query;
     some examples are <literal>random()</literal>, <literal>currval()</literal>,
-    <literal>timeofday()</literal>.
+    <literal>clock_timestamp()</literal>.
    </para>
 
    <para>
@@ -2060,16 +2060,6 @@ memcpy(destination->data, buffer, 40);
         </row>
        </thead>
        <tbody>
-        <row>
-         <entry><type>abstime</type></entry>
-         <entry><type>AbsoluteTime</type></entry>
-         <entry><filename>utils/nabstime.h</filename></entry>
-        </row>
-        <row>
-         <entry><type>bigint</type> (<type>int8</type>)</entry>
-         <entry><type>int64</type></entry>
-         <entry><filename>postgres.h</filename></entry>
-        </row>
         <row>
          <entry><type>boolean</type></entry>
          <entry><type>bool</type></entry>
@@ -2170,11 +2160,6 @@ memcpy(destination->data, buffer, 40);
          <entry><type>regproc</type></entry>
          <entry><filename>postgres.h</filename></entry>
         </row>
-        <row>
-         <entry><type>reltime</type></entry>
-         <entry><type>RelativeTime</type></entry>
-         <entry><filename>utils/nabstime.h</filename></entry>
-        </row>
         <row>
          <entry><type>text</type></entry>
          <entry><type>text*</type></entry>
@@ -2200,11 +2185,6 @@ memcpy(destination->data, buffer, 40);
          <entry><type>Timestamp*</type></entry>
          <entry><filename>datatype/timestamp.h</filename></entry>
         </row>
-        <row>
-         <entry><type>tinterval</type></entry>
-         <entry><type>TimeInterval</type></entry>
-         <entry><filename>utils/nabstime.h</filename></entry>
-        </row>
         <row>
          <entry><type>varchar</type></entry>
          <entry><type>VarChar*</type></entry>
diff --git a/src/backend/access/hash/hashvalidate.c b/src/backend/access/hash/hashvalidate.c
index 8b633c273a5..3428451c76b 100644
--- a/src/backend/access/hash/hashvalidate.c
+++ b/src/backend/access/hash/hashvalidate.c
@@ -311,7 +311,6 @@ check_hash_func_signature(Oid funcid, int16 amprocnum, Oid argtype)
 		 */
 		if ((funcid == F_HASHINT4 || funcid == F_HASHINT4EXTENDED) &&
 			(argtype == DATEOID ||
-			 argtype == ABSTIMEOID || argtype == RELTIMEOID ||
 			 argtype == XIDOID || argtype == CIDOID))
 			 /* okay, allowed use of hashint4() */ ;
 		else if ((funcid == F_TIMESTAMP_HASH ||
diff --git a/src/backend/catalog/system_views.sql b/src/backend/catalog/system_views.sql
index 394aea8e0f5..40bd87888cc 100644
--- a/src/backend/catalog/system_views.sql
+++ b/src/backend/catalog/system_views.sql
@@ -41,7 +41,7 @@ CREATE VIEW pg_shadow AS
         rolreplication AS userepl,
         rolbypassrls AS usebypassrls,
         rolpassword AS passwd,
-        rolvaliduntil::abstime AS valuntil,
+        rolvaliduntil AS valuntil,
         setconfig AS useconfig
     FROM pg_authid LEFT JOIN pg_db_role_setting s
     ON (pg_authid.oid = setrole AND setdatabase = 0)
diff --git a/src/backend/utils/adt/Makefile b/src/backend/utils/adt/Makefile
index 1fb018416ef..5d1f6968db3 100644
--- a/src/backend/utils/adt/Makefile
+++ b/src/backend/utils/adt/Makefile
@@ -16,7 +16,7 @@ OBJS = acl.o amutils.o arrayfuncs.o array_expanded.o array_selfuncs.o \
 	float.o format_type.o formatting.o genfile.o \
 	geo_ops.o geo_selfuncs.o geo_spgist.o inet_cidr_ntop.o inet_net_pton.o \
 	int.o int8.o json.o jsonb.o jsonb_gin.o jsonb_op.o jsonb_util.o \
-	jsonfuncs.o like.o lockfuncs.o mac.o mac8.o misc.o nabstime.o name.o \
+	jsonfuncs.o like.o lockfuncs.o mac.o mac8.o misc.o name.o \
 	network.o network_gist.o network_selfuncs.o network_spgist.o \
 	numeric.o numutils.o oid.o oracle_compat.o \
 	orderedsetaggs.o pg_locale.o pg_lsn.o pg_upgrade_support.o \
diff --git a/src/backend/utils/adt/date.c b/src/backend/utils/adt/date.c
index 307b5e86295..c4992bf1f7d 100644
--- a/src/backend/utils/adt/date.c
+++ b/src/backend/utils/adt/date.c
@@ -29,7 +29,6 @@
 #include "utils/builtins.h"
 #include "utils/date.h"
 #include "utils/datetime.h"
-#include "utils/nabstime.h"
 #include "utils/sortsupport.h"
 
 /*
@@ -1144,55 +1143,6 @@ timestamptz_date(PG_FUNCTION_ARGS)
 }
 
 
-/* abstime_date()
- * Convert abstime to date data type.
- */
-Datum
-abstime_date(PG_FUNCTION_ARGS)
-{
-	AbsoluteTime abstime = PG_GETARG_ABSOLUTETIME(0);
-	DateADT		result;
-	struct pg_tm tt,
-			   *tm = &tt;
-	int			tz;
-
-	switch (abstime)
-	{
-		case INVALID_ABSTIME:
-			ereport(ERROR,
-					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
-					 errmsg("cannot convert reserved abstime value to date")));
-			result = 0;			/* keep compiler quiet */
-			break;
-
-		case NOSTART_ABSTIME:
-			DATE_NOBEGIN(result);
-			break;
-
-		case NOEND_ABSTIME:
-			DATE_NOEND(result);
-			break;
-
-		default:
-			abstime2tm(abstime, &tz, tm, NULL);
-			/* Prevent overflow in Julian-day routines */
-			if (!IS_VALID_JULIAN(tm->tm_year, tm->tm_mon, tm->tm_mday))
-				ereport(ERROR,
-						(errcode(ERRCODE_DATETIME_VALUE_OUT_OF_RANGE),
-						 errmsg("abstime out of range for date")));
-			result = date2j(tm->tm_year, tm->tm_mon, tm->tm_mday) - POSTGRES_EPOCH_JDATE;
-			/* Now check for just-out-of-range dates */
-			if (!IS_VALID_DATE(result))
-				ereport(ERROR,
-						(errcode(ERRCODE_DATETIME_VALUE_OUT_OF_RANGE),
-						 errmsg("abstime out of range for date")));
-			break;
-	}
-
-	PG_RETURN_DATEADT(result);
-}
-
-
 /*****************************************************************************
  *	 Time ADT
  *****************************************************************************/
diff --git a/src/backend/utils/adt/formatting.c b/src/backend/utils/adt/formatting.c
index ec97de0ad27..32781e17122 100644
--- a/src/backend/utils/adt/formatting.c
+++ b/src/backend/utils/adt/formatting.c
@@ -49,7 +49,6 @@
  *	- better number building (formatting) / parsing, now it isn't
  *		  ideal code
  *	- use Assert()
- *	- add support for abstime
  *	- add support for roman number to standard number conversion
  *	- add support for number spelling
  *	- add support for string to string formatting (we must be better
diff --git a/src/backend/utils/adt/selfuncs.c b/src/backend/utils/adt/selfuncs.c
index ea95b8068d9..9b5eb282897 100644
--- a/src/backend/utils/adt/selfuncs.c
+++ b/src/backend/utils/adt/selfuncs.c
@@ -138,7 +138,6 @@
 #include "utils/fmgroids.h"
 #include "utils/index_selfuncs.h"
 #include "utils/lsyscache.h"
-#include "utils/nabstime.h"
 #include "utils/pg_locale.h"
 #include "utils/rel.h"
 #include "utils/selfuncs.h"
@@ -4114,11 +4113,8 @@ convert_to_scalar(Datum value, Oid valuetypid, double *scaledvalue,
 			 */
 		case TIMESTAMPOID:
 		case TIMESTAMPTZOID:
-		case ABSTIMEOID:
 		case DATEOID:
 		case INTERVALOID:
-		case RELTIMEOID:
-		case TINTERVALOID:
 		case TIMEOID:
 		case TIMETZOID:
 			*scaledvalue = convert_timevalue_to_scalar(value, valuetypid);
@@ -4532,9 +4528,6 @@ convert_timevalue_to_scalar(Datum value, Oid typid)
 			return DatumGetTimestamp(value);
 		case TIMESTAMPTZOID:
 			return DatumGetTimestampTz(value);
-		case ABSTIMEOID:
-			return DatumGetTimestamp(DirectFunctionCall1(abstime_timestamp,
-														 value));
 		case DATEOID:
 			return date2timestamp_no_overflow(DatumGetDateADT(value));
 		case INTERVALOID:
@@ -4549,16 +4542,6 @@ convert_timevalue_to_scalar(Datum value, Oid typid)
 				return interval->time + interval->day * (double) USECS_PER_DAY +
 					interval->month * ((DAYS_PER_YEAR / (double) MONTHS_PER_YEAR) * USECS_PER_DAY);
 			}
-		case RELTIMEOID:
-			return (DatumGetRelativeTime(value) * 1000000.0);
-		case TINTERVALOID:
-			{
-				TimeInterval tinterval = DatumGetTimeInterval(value);
-
-				if (tinterval->status != 0)
-					return ((tinterval->data[1] - tinterval->data[0]) * 1000000.0);
-				return 0;		/* for lack of a better idea */
-			}
 		case TIMEOID:
 			return DatumGetTimeADT(value);
 		case TIMETZOID:
diff --git a/src/bin/pg_dump/pg_dumpall.c b/src/bin/pg_dump/pg_dumpall.c
index 41c5ff89b75..d259e94f73b 100644
--- a/src/bin/pg_dump/pg_dumpall.c
+++ b/src/bin/pg_dump/pg_dumpall.c
@@ -812,7 +812,7 @@ dumpRoles(PGconn *conn)
 						  "false as rolcanlogin, "
 						  "-1 as rolconnlimit, "
 						  "null::text as rolpassword, "
-						  "null::abstime as rolvaliduntil, "
+						  "null::timestamptz as rolvaliduntil, "
 						  "false as rolreplication, "
 						  "false as rolbypassrls, "
 						  "null as rolcomment, "
diff --git a/src/include/catalog/pg_aggregate.h b/src/include/catalog/pg_aggregate.h
index 13f1bce5afa..64e99530a8f 100644
--- a/src/include/catalog/pg_aggregate.h
+++ b/src/include/catalog/pg_aggregate.h
@@ -176,7 +176,6 @@ DATA(insert ( 2117	n 0 int2larger		-				int2larger			-	-	-				-				-				f f r r
 DATA(insert ( 2118	n 0 oidlarger		-				oidlarger			-	-	-				-				-				f f r r 610		26		0	0		0	_null_ _null_ ));
 DATA(insert ( 2119	n 0 float4larger	-				float4larger		-	-	-				-				-				f f r r 623		700		0	0		0	_null_ _null_ ));
 DATA(insert ( 2120	n 0 float8larger	-				float8larger		-	-	-				-				-				f f r r 674		701		0	0		0	_null_ _null_ ));
-DATA(insert ( 2121	n 0 int4larger		-				int4larger			-	-	-				-				-				f f r r 563		702		0	0		0	_null_ _null_ ));
 DATA(insert ( 2122	n 0 date_larger		-				date_larger			-	-	-				-				-				f f r r 1097	1082	0	0		0	_null_ _null_ ));
 DATA(insert ( 2123	n 0 time_larger		-				time_larger			-	-	-				-				-				f f r r 1112	1083	0	0		0	_null_ _null_ ));
 DATA(insert ( 2124	n 0 timetz_larger	-				timetz_larger		-	-	-				-				-				f f r r 1554	1266	0	0		0	_null_ _null_ ));
@@ -199,7 +198,6 @@ DATA(insert ( 2133	n 0 int2smaller		-				int2smaller			-	-	-				-				-				f f r
 DATA(insert ( 2134	n 0 oidsmaller		-				oidsmaller			-	-	-				-				-				f f r r 609		26		0	0		0	_null_ _null_ ));
 DATA(insert ( 2135	n 0 float4smaller	-				float4smaller		-	-	-				-				-				f f r r 622		700		0	0		0	_null_ _null_ ));
 DATA(insert ( 2136	n 0 float8smaller	-				float8smaller		-	-	-				-				-				f f r r 672		701		0	0		0	_null_ _null_ ));
-DATA(insert ( 2137	n 0 int4smaller		-				int4smaller			-	-	-				-				-				f f r r 562		702		0	0		0	_null_ _null_ ));
 DATA(insert ( 2138	n 0 date_smaller	-				date_smaller		-	-	-				-				-				f f r r 1095	1082	0	0		0	_null_ _null_ ));
 DATA(insert ( 2139	n 0 time_smaller	-				time_smaller		-	-	-				-				-				f f r r 1110	1083	0	0		0	_null_ _null_ ));
 DATA(insert ( 2140	n 0 timetz_smaller	-				timetz_smaller		-	-	-				-				-				f f r r 1552	1266	0	0		0	_null_ _null_ ));
diff --git a/src/include/catalog/pg_amop.h b/src/include/catalog/pg_amop.h
index f850be490af..57674c69568 100644
--- a/src/include/catalog/pg_amop.h
+++ b/src/include/catalog/pg_amop.h
@@ -263,16 +263,6 @@ DATA(insert (	428   17 17 3 s 1955	403 0 ));
 DATA(insert (	428   17 17 4 s 1960	403 0 ));
 DATA(insert (	428   17 17 5 s 1959	403 0 ));
 
-/*
- *	btree abstime_ops
- */
-
-DATA(insert (	421   702 702 1 s  562	403 0 ));
-DATA(insert (	421   702 702 2 s  564	403 0 ));
-DATA(insert (	421   702 702 3 s  560	403 0 ));
-DATA(insert (	421   702 702 4 s  565	403 0 ));
-DATA(insert (	421   702 702 5 s  563	403 0 ));
-
 /*
  *	btree datetime_ops
  */
@@ -462,26 +452,6 @@ DATA(insert (	2099   790 790 3 s	900 403 0 ));
 DATA(insert (	2099   790 790 4 s	905 403 0 ));
 DATA(insert (	2099   790 790 5 s	903 403 0 ));
 
-/*
- *	btree reltime_ops
- */
-
-DATA(insert (	2233   703 703 1 s	568 403 0 ));
-DATA(insert (	2233   703 703 2 s	570 403 0 ));
-DATA(insert (	2233   703 703 3 s	566 403 0 ));
-DATA(insert (	2233   703 703 4 s	571 403 0 ));
-DATA(insert (	2233   703 703 5 s	569 403 0 ));
-
-/*
- *	btree tinterval_ops
- */
-
-DATA(insert (	2234   704 704 1 s	813 403 0 ));
-DATA(insert (	2234   704 704 2 s	815 403 0 ));
-DATA(insert (	2234   704 704 3 s	811 403 0 ));
-DATA(insert (	2234   704 704 4 s	816 403 0 ));
-DATA(insert (	2234   704 704 5 s	814 403 0 ));
-
 /*
  *	btree array_ops
  */
@@ -589,10 +559,6 @@ DATA(insert (	2223   17 17 1 s 1955 405 0 ));
 DATA(insert (	2225   28 28 1 s	352 405 0 ));
 /* cid_ops */
 DATA(insert (	2226   29 29 1 s	385 405 0 ));
-/* abstime_ops */
-DATA(insert (	2227   702 702 1 s	560 405 0 ));
-/* reltime_ops */
-DATA(insert (	2228   703 703 1 s	566 405 0 ));
 /* text_pattern_ops */
 DATA(insert (	2229   25 25 1 s	98	405 0 ));
 /* bpchar_pattern_ops */
@@ -993,18 +959,6 @@ DATA(insert (	4070	701  701 3 s	   670	  3580 0 ));
 DATA(insert (	4070	701  701 4 s	   675	  3580 0 ));
 DATA(insert (	4070	701  701 5 s	   674	  3580 0 ));
 
-/* minmax abstime */
-DATA(insert (	4072	702  702 1 s	   562	  3580 0 ));
-DATA(insert (	4072	702  702 2 s	   564	  3580 0 ));
-DATA(insert (	4072	702  702 3 s	   560	  3580 0 ));
-DATA(insert (	4072	702  702 4 s	   565	  3580 0 ));
-DATA(insert (	4072	702  702 5 s	   563	  3580 0 ));
-/* minmax reltime */
-DATA(insert (	4073	703  703 1 s	   568	  3580 0 ));
-DATA(insert (	4073	703  703 2 s	   570	  3580 0 ));
-DATA(insert (	4073	703  703 3 s	   566	  3580 0 ));
-DATA(insert (	4073	703  703 4 s	   571	  3580 0 ));
-DATA(insert (	4073	703  703 5 s	   569	  3580 0 ));
 /* minmax macaddr */
 DATA(insert (	4074	829  829 1 s	  1222	  3580 0 ));
 DATA(insert (	4074	829  829 2 s	  1223	  3580 0 ));
diff --git a/src/include/catalog/pg_amproc.h b/src/include/catalog/pg_amproc.h
index 1c958462074..ca893873e22 100644
--- a/src/include/catalog/pg_amproc.h
+++ b/src/include/catalog/pg_amproc.h
@@ -76,7 +76,6 @@ typedef FormData_pg_amproc *Form_pg_amproc;
 
 /* btree */
 DATA(insert (	397   2277 2277 1 382 ));
-DATA(insert (	421   702 702 1 357 ));
 DATA(insert (	423   1560 1560 1 1596 ));
 DATA(insert (	424   16 16 1 1693 ));
 DATA(insert (	426   1042 1042 1 1078 ));
@@ -135,8 +134,6 @@ DATA(insert (	2095   25 25 2 3332 ));
 DATA(insert (	2097   1042 1042 1 2180 ));
 DATA(insert (	2097   1042 1042 2 3333 ));
 DATA(insert (	2099   790 790 1  377 ));
-DATA(insert (	2233   703 703 1  380 ));
-DATA(insert (	2234   704 704 1  381 ));
 DATA(insert (	2789   27 27 1 2794 ));
 DATA(insert (	2968   2950 2950 1 2960 ));
 DATA(insert (	2968   2950 2950 2 3300 ));
@@ -202,10 +199,6 @@ DATA(insert (	2225   28 28 1 450 ));
 DATA(insert (	2225   28 28 2 425));
 DATA(insert (	2226   29 29 1 450 ));
 DATA(insert (	2226   29 29 2 425 ));
-DATA(insert (	2227   702 702 1 450 ));
-DATA(insert (	2227   702 702 2 425 ));
-DATA(insert (	2228   703 703 1 450 ));
-DATA(insert (	2228   703 703 2 425 ));
 DATA(insert (	2229   25 25 1 400 ));
 DATA(insert (	2229   25 25 2 448 ));
 DATA(insert (	2231   1042 1042 1 1080 ));
@@ -427,16 +420,6 @@ DATA(insert (	4070   701	 700  2  3384 ));
 DATA(insert (	4070   701	 700  3  3385 ));
 DATA(insert (	4070   701	 700  4  3386 ));
 
-/* minmax abstime */
-DATA(insert (	4072   702	 702  1  3383 ));
-DATA(insert (	4072   702	 702  2  3384 ));
-DATA(insert (	4072   702	 702  3  3385 ));
-DATA(insert (	4072   702	 702  4  3386 ));
-/* minmax reltime */
-DATA(insert (	4073   703	 703  1  3383 ));
-DATA(insert (	4073   703	 703  2  3384 ));
-DATA(insert (	4073   703	 703  3  3385 ));
-DATA(insert (	4073   703	 703  4  3386 ));
 /* minmax macaddr */
 DATA(insert (	4074   829	 829  1  3383 ));
 DATA(insert (	4074   829	 829  2  3384 ));
diff --git a/src/include/catalog/pg_cast.h b/src/include/catalog/pg_cast.h
index 17827531ad2..94b94e22d5a 100644
--- a/src/include/catalog/pg_cast.h
+++ b/src/include/catalog/pg_cast.h
@@ -265,32 +265,19 @@ DATA(insert (  3402  25    0 i i ));
 /*
  * Datetime category
  */
-DATA(insert (  702 1082 1179 a f ));
-DATA(insert (  702 1083 1364 a f ));
-DATA(insert (  702 1114 2023 i f ));
-DATA(insert (  702 1184 1173 i f ));
-DATA(insert (  703 1186 1177 i f ));
 DATA(insert ( 1082 1114 2024 i f ));
 DATA(insert ( 1082 1184 1174 i f ));
 DATA(insert ( 1083 1186 1370 i f ));
 DATA(insert ( 1083 1266 2047 i f ));
-DATA(insert ( 1114	702 2030 a f ));
 DATA(insert ( 1114 1082 2029 a f ));
 DATA(insert ( 1114 1083 1316 a f ));
 DATA(insert ( 1114 1184 2028 i f ));
-DATA(insert ( 1184	702 1180 a f ));
 DATA(insert ( 1184 1082 1178 a f ));
 DATA(insert ( 1184 1083 2019 a f ));
 DATA(insert ( 1184 1114 2027 a f ));
 DATA(insert ( 1184 1266 1388 a f ));
-DATA(insert ( 1186	703 1194 a f ));
 DATA(insert ( 1186 1083 1419 a f ));
 DATA(insert ( 1266 1083 2046 a f ));
-/* Cross-category casts between int4 and abstime, reltime */
-DATA(insert (	23	702    0 e b ));
-DATA(insert (  702	 23    0 e b ));
-DATA(insert (	23	703    0 e b ));
-DATA(insert (  703	 23    0 e b ));
 
 /*
  * Geometric category
diff --git a/src/include/catalog/pg_opclass.h b/src/include/catalog/pg_opclass.h
index 28dbc747d5b..da477cac58d 100644
--- a/src/include/catalog/pg_opclass.h
+++ b/src/include/catalog/pg_opclass.h
@@ -90,7 +90,6 @@ typedef FormData_pg_opclass *Form_pg_opclass;
  * ----------------
  */
 
-DATA(insert (	403		abstime_ops			PGNSP PGUID  421  702 t 0 ));
 DATA(insert (	403		array_ops			PGNSP PGUID  397 2277 t 0 ));
 DATA(insert (	405		array_ops			PGNSP PGUID  627 2277 t 0 ));
 DATA(insert (	403		bit_ops				PGNSP PGUID  423 1560 t 0 ));
@@ -173,13 +172,9 @@ DATA(insert (	405		bytea_ops			PGNSP PGUID 2223   17 t 0 ));
 DATA(insert (	403		tid_ops				PGNSP PGUID 2789   27 t 0 ));
 DATA(insert (	405		xid_ops				PGNSP PGUID 2225   28 t 0 ));
 DATA(insert (	405		cid_ops				PGNSP PGUID 2226   29 t 0 ));
-DATA(insert (	405		abstime_ops			PGNSP PGUID 2227  702 t 0 ));
-DATA(insert (	405		reltime_ops			PGNSP PGUID 2228  703 t 0 ));
 DATA(insert (	405		text_pattern_ops	PGNSP PGUID 2229   25 f 0 ));
 DATA(insert (	405		varchar_pattern_ops PGNSP PGUID 2229   25 f 0 ));
 DATA(insert (	405		bpchar_pattern_ops	PGNSP PGUID 2231 1042 f 0 ));
-DATA(insert (	403		reltime_ops			PGNSP PGUID 2233  703 t 0 ));
-DATA(insert (	403		tinterval_ops		PGNSP PGUID 2234  704 t 0 ));
 DATA(insert (	405		aclitem_ops			PGNSP PGUID 2235 1033 t 0 ));
 DATA(insert (	783		box_ops				PGNSP PGUID 2593  603 t 0 ));
 DATA(insert (	783		point_ops			PGNSP PGUID 1029  600 t 603 ));
@@ -223,8 +218,6 @@ DATA(insert (	3580	oid_minmax_ops			PGNSP PGUID 4068	26 t 26 ));
 DATA(insert (	3580	tid_minmax_ops			PGNSP PGUID 4069	27 t 27 ));
 DATA(insert (	3580	float4_minmax_ops		PGNSP PGUID 4070   700 t 700 ));
 DATA(insert (	3580	float8_minmax_ops		PGNSP PGUID 4070   701 t 701 ));
-DATA(insert (	3580	abstime_minmax_ops		PGNSP PGUID 4072   702 t 702 ));
-DATA(insert (	3580	reltime_minmax_ops		PGNSP PGUID 4073   703 t 703 ));
 DATA(insert (	3580	macaddr_minmax_ops		PGNSP PGUID 4074   829 t 829 ));
 DATA(insert (	3580	macaddr8_minmax_ops		PGNSP PGUID 4109   774 t 774 ));
 DATA(insert (	3580	inet_minmax_ops			PGNSP PGUID 4075   869 f 869 ));
